如何通过RevitPythonShell / IronPython访问活动Revit计划中的字段?

问题描述 投票:1回答:1

我正在为Revit 2016开发IronPython脚本。对于初学者,我试图在活动的Revit计划中访问值(作为文本),并将它们加载到变量中。这对于非计算值非常有效。

但是,我的一些计划字段是计算的。这是一个示例时间表(这里的所有值都是计算出来的):

Schedule Snippet

Revit API显示了两种方法,称为TableView.GetCalculatedValueName()and TableView.GetCalculatedValueText(),我想使用它,但似乎不像宣传的那样工作。

doc = __revit__.ActiveUIDocument.Document
uidoc = __revit__.ActiveUIDocument

schedule = doc.ActiveView
tableData = schedule.GetTableData()
print(tableData)

tableName = schedule.GetCellText(SectionType.Header,0,0)
qty = schedule.GetCalculatedValueText(SectionType.Body,4,1)
calcValName = schedule.GetCalculatedValueName(SectionType.Body,4,1)
print(tableName)
print("Calculated Qty is: " + qty)
print("Calculated Value Name is: " + calcValName)

运行此代码(在Revit中)会生成以下输出:

88-06134-01
Calculated Qty is: 
Calculated Value Name is: 

我想指出使用TableView.GetCellText()实际上对计算值有效,但是我真的想在这里工作的是GetCalculatedValueName()

python ironpython revit-api revitpythonshell
1个回答
0
投票

我已经做了同样的事情,但在c#for Revit 2019。我希望你能理解它。

您可以在不导出的情况下访问计划数据的值。首先,获取所有计划并逐个单元地读取数据。其次,以键,值对的形式创建字典和存储数据。现在,您可以根据需要使用计划数据。我在Revit 2019中尝试了这个。这是实现。

public void getScheduleData(Document doc)
{
    FilteredElementCollector collector = new FilteredElementCollector(doc);
    IList<Element> collection = collector.OfClass(typeof(ViewSchedule)).ToElements();

    foreach (Element e in collection)
    {
        ViewSchedule viewSchedule = e as ViewSchedule;
        TableData table = viewSchedule.GetTableData();
        TableSectionData section = table.GetSectionData(SectionType.Body);
        int nRows = section.NumberOfRows;
        int nColumns = section.NumberOfColumns;

        if (nRows > 1)
        {
            List<List<string>> scheduleData = new List<List<string>>();
            for (int i = 0; i < nRows; i++)
            {
                List<string> rowData = new List<string>();

                for (int j = 0; j < nColumns; j++)
                {
                    rowData.Add(viewSchedule.GetCellText(SectionType.Body, i, j));
                }
                scheduleData.Add(rowData);
            }

            List<string> columnData = scheduleData[0];
            scheduleData.RemoveAt(0);

            DataMapping(columnData, scheduleData);
        }
    }
}

public static void DataMapping(List<string> keyData, List<List<string>>valueData)
{
    List<Dictionary<string, string>> items= new List<Dictionary<string, string>>();

    string prompt = "Key/Value";
    prompt += Environment.NewLine;

    foreach (List<string> list in valueData)
    {
        for (int key=0, value =0 ; key< keyData.Count && value< list.Count; key++,value++)
        {
            Dictionary<string, string> newItem = new Dictionary<string, string>();

            string k = keyData[key];
            string v = list[value];
            newItem.Add(k, v);
            items.Add(newItem);
        }
    }

    foreach (Dictionary<string, string> item in items)
    {
        foreach (KeyValuePair<string, string> kvp in item)
        {
            prompt += "Key: " + kvp.Key + ",Value: " + kvp.Value;
            prompt += Environment.NewLine;
        }
    }

    Autodesk.Revit.UI.TaskDialog.Show("Revit", prompt);
}
© www.soinside.com 2019 - 2024. All rights reserved.